class Rational(n: Int, d: Int) {
  def num = n
  def denom = d

  def add(that: Rational): Rational = new Rational(
    this.num * that.denom + this.denom * that.num,
    this.denom * that.denom
  )

  def neg: Rational = new Rational(-num, denom)

  def smallerThan(that: Rational): Boolean = this.num * that.denom < that.num * this.denom

  def max(that: Rational): Rational = if (this.smallerThan(that)) that else this

  override def toString = num + "/" + denom
}

val r1 = new Rational(1, 3)
val r2 = new Rational(2, 3)
val r3 = r1.add(r2)

r3

r2.neg

r2.smallerThan(r1)
r2.smallerThan(r3)

r2.max(r1)
r2.max(r3)